function getMyDSID() {
	return Property.getProperty('/system/dSID');
}



function preventUninstall() {
	var fPrevent=false;
    var oZoneArray=Property.getNode('/apartment/zones').getChildren();
    for (var iIndex=0;iIndex<oZoneArray.length;iIndex++) {
    	var iZoneID=oZoneArray[iIndex].getChild('ZoneID').getValue();
    	if (iZoneID!=0) {
    		var zZone = getZoneByID(iZoneID);    		
    		var oldConfig = zZone.getTemperatureControlConfiguration();
    		if (oldConfig.IsConfigured)
	    		if (oldConfig.ControlMode != ControlModeIDs.ControlModeIDOff) {
	    		    Property.setProperty('system/preventUninstall',true);
	    		    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
	    		    return;
	    		}    		
    	}
    }
    Property.setProperty('system/preventUninstall',false);
    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
}

if (raisedEvent.name == 'heating-controller.controller-config') {
	if (raisedEvent.parameter.actions == 'sync') {
	}
	if (raisedEvent.parameter.actions == 'resetControllerMode') {
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var zZone = getZoneByID(parseInt('' + zoneID, 10));

			/*
			 * oParameter.ControlMode = oDataObject.controllerMode;
			 * oParameter.id = iZoneID;
			 * 
			 * oParameter.CtrlDSUID = me.getControllerDsuidForZone(iZoneID);
			 * oParameter.ControlDSUID = me.getControllerDsuidForZone(iZoneID);
			 */

			var dSM = getControllerDsuidForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no dsm found for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'resetControllerMode',
					'result' : -1
				}).raise();
			} else {
				zZone.setTemperatureControlConfiguration(dSM, {
					ControlMode : ControlModeIDs.ControlModeIDOff
				});
				lInfo.logln('remove controller from zone ' + zoneID + ' altogether');
				zZone.setTemperatureControlConfiguration("0000000000000000000000000000000000");


				storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);

				var defID = DefinitionIDs.ModeOff;
				if (raisedEvent.parameter.definitionID != null) {
					defID = parseInt(raisedEvent.parameter.definitionID);
				}
				storeParameter('controllerConfig/' + zoneID + '/definitionID', defID);

				if (raisedEvent.parameter.autoselect == null) {
					Property.getNode('controllerConfig/' + zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}
				Property.store();

				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'resetControllerMode',
					'result' : 0
				}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if ((raisedEvent.parameter.actions == 'setControllerModeAutomatic') &&
		(raisedEvent.parameter.autoselect != null)) {
        var zoneID = raisedEvent.parameter.zoneID;
		lInfo.logln('enable autoselection of pid controller configuration for zone ' + zoneID);
		var oldDefinitionID = parseInt("" + Property.getProperty('controllerConfig/' + zoneID + '/definitionID'),10);
		var oldAutomatic = parseInt("" + Property.getProperty('controllerConfig/' + zoneID + '/autoselect'),10);

		storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);
		storeParameter('controllerConfig/' + zoneID + '/autoselect', raisedEvent.parameter.autoselect);
		storeParameter('controllerConfig/' + zoneID + '/emergenyValue', raisedEvent.parameter.emergency);
		// reset template ID to unknown if there was a previous selection
		if (oldAutomatic != 1) {
			storeParameter('controllerConfig/' + zoneID + '/definitionID', raisedEvent.parameter.definitionID);
			new Event('heating-controller.autoselect', {
				'zoneID' : zoneID
				
			}).raise();
		} else {
			var zZone = getZoneByID(parseInt('' + zoneID, 10));
			var oldConfig = zZone.getTemperatureControlConfiguration();
			oldConfig.EmergencyValue=raisedEvent.parameter.emergency;
			zZone.setTemperatureControlConfiguration(oldConfig.ControlDSUID, oldConfig);
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeAutomatic',
				'result' : 0
			}).raise();
		}
		Property.store();
	}
	if (raisedEvent.parameter.actions == 'setControllerModePID') {
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getControllerDsuidForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no heating controller found for zone ' + zoneID);
				autoSelectDsm(zoneID);
				dSM = getControllerDsuidForZone(zoneID);
			}
			if (dSM == null) {
				lWarn.logln('no heating controller could be allocated for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModePID',
					'result' : -1
				}).raise();
				resetControllerMode(zoneID, DefinitionIDs.AutoSelectionNoController);
			} else {
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oldConfig = zZone.getTemperatureControlConfiguration();
				var fNewValues = (oldConfig.ControlMode != ControlModeIDs.ControlModeIDPID);

				if (raisedEvent.parameter.autoselect == null) {
					if (Property.getNode('controllerConfig/' + zoneID)!=null) {
						Property.getNode('controllerConfig/' + zoneID).removeChild('autoselect');
					}
				}
				else {
					storeParameter('controllerConfig/' + zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}

				if (raisedEvent.parameter.emergency != null) {
					storeParameter('controllerConfig/' + zoneID + '/emergenyValue', parseInt('' + raisedEvent.parameter.emergency, 10));
				} 
				else {
					var forceUpdateNeeded = true;
					if ((Property.getNode('controllerConfig/' + zoneID)!=null) && 
						(Property.getNode('controllerConfig/' + zoneID + '/emergenyValue')!=null)) {
						var emergencyValue=Property.getNode('controllerConfig/' + zoneID + '/emergenyValue').getValue();
						forceUpdateNeeded = !((emergencyValue > 0) && (emergencyValue <= 100));
					}
					if (forceUpdateNeeded == true) {
						storeParameter('controllerConfig/' + zoneID + '/emergenyValue', 75);
					}
				}

				storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);
				storeParameter('controllerConfig/' + zoneID + '/definitionID', raisedEvent.parameter.definitionID);

				Property.store();
				setZoneParameters(zZone, true, ControlModeIDs.ControlModeIDPID);

				if (fNewValues) {
					lInfo.logln('!!! Changing controlmode -> Reseting temperature Values');
					var node = Property.getNode('modes/' + zoneID + '/Temperature');
					if (node != null) {
						try {
							var tempOff = node.getChild('OffTemperatur').getValue();
							var tempEco = node.getChild('EcoTemperatur').getValue();
							var tempNight = node.getChild('NightTemperatur').getValue();
							var tempHoliday = node.getChild('HolidayTemperatur').getValue();
							var tempComfort = node.getChild('ComfortTemperatur').getValue();
							var tempNotUsed = node.getChild('notUsedTemperatur').getValue();
							var tempCooling = node.getChild('coolingTemperatur').getValue();
							var tempCoolingOff = node.getChild('coolingOffTemperatur').getValue();
							var temperatureValues = {
								'Off'        : tempOff,
								'Comfort'    : tempComfort,
								'Economy'    : tempEco,
								'NotUsed'    : tempNotUsed,
								'Night'      : tempNight,
								'Holiday'    : tempHoliday,
								'Cooling'    : tempCooling,
								'CoolingOff' : tempCoolingOff
							};
							zZone.setTemperatureControlValues(temperatureValues);
						} catch (e) {
							lWarn.logln('Error on updateTemperature. ' + e);
							zZone.setTemperatureControlValues(defaultTemperatureValues);
						}
					} else {
						zZone.setTemperatureControlValues(defaultTemperatureValues);
					}
				} else {
                    lInfo.logln('!!! Changing controlmode -> Rewriting temperature Values');
                    updateTemperature(zoneID);
                }

				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModePID',
					'result' : 0
				}).raise();

				// new
				// Event('HeatingControllerSetup',{'zoneID':zoneID,'HeatingControllerTypeId':raisedEvent.parameter.definitionID}).raise();
				var handle = new WebserviceConnection();
				var queryString='heatingControllerTypeId=' + raisedEvent.parameter.definitionID + '&zoneid=' + zoneID+ '&dSSId=' + getMyDSID();
				lInfo.logln('public/dss/v1_1/DSSHeating/SetHeatingControllerType ' + queryString);
				handle.request('public/dss/v1_1/DSSHeating/SetHeatingControllerType',queryString , 'POST', {
					'Content-Type' : 'application/json',
					'NotificationTextIsUrlEncodedUtf7' : 'true'
				}, '', true, function(code, retdata) {
					if (code === 200) {
						lInfo.logln(': OK [' + code + ']');
					} else {
						lWarn.logln(': FAILED! Server replied: "' + code + '"');
					}
					lInfo.logln(retdata);
				});
				new Event('heating-controller.operation-mode',{'zoneID':zoneID,'actions':'evaluateRealActiveMode'}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeZoneFollower') {
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getControllerDsuidForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no heating controller found for zone ' + zoneID);
				autoSelectDsm(zoneID);
				dSM = getControllerDsuidForZone(zoneID);
			}
			if (dSM == null) {
				lWarn.logln('no heating controller could be allocated for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeZoneFollower',
					'result' : -1
				}).raise();
				resetControllerMode(zoneID, DefinitionIDs.AutoSelectionNoController);
			} else {
				var offset = raisedEvent.parameter.offset;
				var followedZone = raisedEvent.parameter.followedZone;
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oParameter ={
					ControlMode : ControlModeIDs.ControlModeIDZoneFollower,
					ReferenceZone : followedZone,
					CtrlOffset : offset,
					EmergencyValue : 75
				};
				if (raisedEvent.parameter.emergency!=null)
					oParameter.EmergencyValue=raisedEvent.parameter.emergency;

				zZone.setTemperatureControlConfiguration(dSM, oParameter);
				
				
				storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);
				storeParameter('controllerConfig/' + zoneID + '/definitionID', DefinitionIDs.ModeZoneFollower);
				storeParameter('controllerConfig/' + zoneID + '/offset', offset);
				storeParameter('controllerConfig/' + zoneID + '/followedZone', followedZone);
				storeParameter('controllerConfig/' + zoneID + '/emergenyValue', oParameter.EmergencyValue);

				if (raisedEvent.parameter.autoselect == null) {
					Property.getNode('controllerConfig/' + zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}

				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeZoneFollower',
					'result' : 0
				}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeFixedValue') {
		try {
			var zoneID = raisedEvent.parameter.zoneID;
			var dSM = getControllerDsuidForZone(zoneID);
			if (dSM == null) {
				lWarn.logln('no heating controller found for zone ' + zoneID);
				autoSelectDsm(zoneID);
				dSM = getControllerDsuidForZone(zoneID);
			}
			if (dSM == null) {
				lWarn.logln('no heating controller could be allocated for zone ' + zoneID);
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeFixedValue',
					'result' : -1
				}).raise();
				resetControllerMode(zoneID, DefinitionIDs.AutoSelectionNoController);
			} else {
				var zZone = getZoneByID(parseInt('' + zoneID, 10));
				var oldConfig = zZone.getTemperatureControlConfiguration();
				var fNewValues = (oldConfig.ControlMode != ControlModeIDs.ControlModeIDFixed);
				zZone.setTemperatureControlConfiguration(dSM, {
					ControlMode : ControlModeIDs.ControlModeIDFixed
				});

				storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);
				storeParameter('controllerConfig/' + zoneID + '/definitionID', DefinitionIDs.ModeFixedValue);

				if (raisedEvent.parameter.autoselect == null) {
					Property.getNode('controllerConfig/' + zoneID).removeChild('autoselect');
				}
				else {
					storeParameter('controllerConfig/' + zoneID + '/autoselect', raisedEvent.parameter.autoselect);
				}

				if (fNewValues) {
					lInfo.logln('!!! Changing controlmode -> Reseting temperature Values');

					var node = Property.getNode('modes/' + zoneID +'/Percent');
					if (node != null) {
						try {
							var tempOff = node.getChild('OffTemperatur').getValue();
							var tempEco = node.getChild('EcoTemperatur').getValue();
							var tempNight = node.getChild('NightTemperatur').getValue();
							var tempHoliday = node.getChild('HolidayTemperatur').getValue();
							var tempComfort = node.getChild('ComfortTemperatur').getValue();
							var tempNotUsed = node.getChild('notUsedTemperatur').getValue();
							var tempCooling = node.getChild('coolingTemperatur').getValue();
							var tempCoolingOff = node.getChild('coolingOffTemperatur').getValue();
							var temperatureValues = {
								'Off'        : tempOff,
								'Comfort'    : tempComfort,
								'Economy'    : tempEco,
								'NotUsed'    : tempNotUsed,
								'Night'      : tempNight,
								'Holiday'    : tempHoliday,
								'Cooling'    : tempCooling,
								'CoolingOff' : tempCoolingOff
							};
							zZone.setTemperatureControlValues(temperatureValues);
						} catch (e) {
							lWarn.logln('Error on updateTemperature. ' + e);
							zZone.setTemperatureControlValues(defaultFixedValues);
						}
					} else {
						zZone.setTemperatureControlValues(defaultFixedValues);
					}
				} else {
					lInfo.logln('!!! Changing controlmode -> Rewriting temperature Values');
					updateTemperature(zoneID);
				}

				Property.store();
				new Event('heating-controller.answer', {
					'requestingEvent' : 'heating-controller.controller-config',
					'requestingAction' : 'setControllerModeFixedValue',
					'result' : 0
				}).raise();
				new Event('heating-controller.operation-mode',{'zoneID':zoneID,'actions':'evaluateRealActiveMode'}).raise();
			}
		} catch (e) {
			lWarn.logln('Error on heating-controller.controller-config ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'setControllerModeManual') {
		var zoneID = raisedEvent.parameter.zoneID;
		try {
			storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);
			storeParameter('controllerConfig/' + zoneID + '/fManualOverride', true);

			if (raisedEvent.parameter.autoselect == null) {
				Property.getNode('controllerConfig/' + zoneID).removeChild('autoselect');
			}
			else {
				storeParameter('controllerConfig/' + zoneID + '/autoselect', raisedEvent.parameter.autoselect);
			}

			var manualValue = 0;
			if (raisedEvent.parameter.value != null)
				manualValue = parseInt('' + raisedEvent.parameter.value, 10);
			var zZone = getZoneByID(parseInt('' + zoneID, 10));
			lInfo.logln('setControllerModeManual for zone ' + zoneID);
			var dSM = getControllerDsuidForZone(zoneID);
			zZone.setTemperatureControlConfiguration(dSM, {
				ControlMode : ControlModeIDs.ControlModeIDManual,
				ManualValue : manualValue
			});
			Property.store();
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeManual',
				'result' : 0
			}).raise();			
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
	if (raisedEvent.parameter.actions == 'checkPreventUninstall') {
		preventUninstall();
        Property.store();
	}
	if (raisedEvent.parameter.actions == 'resetControllerModeManual') {
        var zoneID = raisedEvent.parameter.zoneID;
		try {

			storeParameter('controllerConfig/' + zoneID + '/zoneID', zoneID);
			storeParameter('controllerConfig/' + zoneID + '/fManualOverride', false);
			Property.store();

			var definitionID = Property.getProperty('controllerConfig/' + zoneID + '/definitionID');
			if (definitionID == null) {
				lInfo.logln('resetControllerModeManual for zone ' + zoneID + ' to OFF');
				new Event('heating-controller.controller-config', {
					'zoneID' : zoneID,
					'actions' : 'resetControllerMode'
				}).raise();
			} else if (definitionID == DefinitionIDs.ModeOff) {
				lInfo.logln('resetControllerModeManual for zone ' + zoneID + ' to OFF');
				new Event('heating-controller.controller-config', {
					'zoneID' : zoneID,
					'actions' : 'resetControllerMode'
				}).raise();
			} else if (definitionID == DefinitionIDs.ModeZoneFollower) {
				lInfo.logln('resetControllerModeManual for zone ' + zoneID + ' to zoneFollower');
				var offset = Property.getProperty('controllerConfig/' + zoneID + '/offset');
				var followedZone = Property.getProperty('controllerConfig/' + zoneID + '/followedZone');
				var emergenyValue = Property.getProperty('controllerConfig/' + zoneID + '/emergenyValue');
				
				
				new Event('heating-controller.controller-config', {
					'zoneID' : zoneID,
					'actions' : 'setControllerModeZoneFollower',
					'offset' : offset,
					'followedZone' : followedZone,
					'emergency': emergenyValue
				}).raise();
			} else if (definitionID == DefinitionIDs.ModeFixedValue) {
				lInfo.logln('resetControllerModeManual for zone ' + zoneID + ' to fixedValue');
				new Event('heating-controller.controller-config', {
					'zoneID' : zoneID,
					'actions' : 'setControllerModeFixedValue'
				}).raise();
			} else if (definitionID > 0) {
				var emergenyValue = Property.getProperty('controllerConfig/' + zoneID + '/emergenyValue');
				
				lInfo.logln('resetControllerModeManual for zone ' + zoneID + ' to PID with definition ' + definitionID);
				new Event('heating-controller.controller-config', {
					'zoneID' : zoneID,
					'actions' : 'setControllerModePID',
					'definitionID' : definitionID,
					'emergency': emergenyValue
				}).raise();
			}
			new Event('heating-controller.answer', {
				'requestingEvent' : 'heating-controller.controller-config',
				'requestingAction' : 'setControllerModeManual',
				'result' : 0
			}).raise();
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
		new Event('heating-controller.controller-config', {
			'actions' : 'checkPreventUninstall'
		}).raise();
	}
}
